/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *	JԂƏ
 *
 * \par Application note:
 *	AVR064: LCDo͕txĎ
 *
 * \par Documentation:
 *	IȺގAxׁ߲A߲אݒAx޲ɂĂreadme.html
 *	B
 *
 * \author
 *	Atmel Corporation: http://www.atmel.com \n
 *	xEҰ: avr@atmel.com
 *
 * $Name: RELEASE_1_1 $
 * $Revision: 1.3 $
 * $RCSfile: Main.c,v $
 * $Date: 2006/02/16 18:11:22 $  \n
 ******************************************************************************/

// ݸٰ ̧
#include "Main.h"
#include "Temperature.h"
#include "RTC.h"
#include "UART.h"
#include "Lcd_functions.h"
#include "LCD_driver.h"
#include "Buttons.h"

/*! \brief	喳JԂ܂ގ֐
 */
void main(void)
{
  Initialization();						// 
  while(1)								// 喳JԂ
  {
	Time_update();						// XV
	ADC_conversion();					// x
	Store_RX_data();					// Mޯ̧SRAMްi[
	Send_TX_data();						// SRAM瑗Mޯ̧ްi[AMJn
	CheckButtons();						// STK500̖tł̎gpғ͌
	LCD_update();						// LCDXV
  }
}

/*! \brief	ATmega169(P)̊e
 */
void Initialization(void)
{
  CLKPR = (1<<CLKPCE);					//  ۯOuύX
  CLKPR = (1<<CLKPS1) | (1<<CLKPS0);	//  ۯOu8ݒ(8MHz/8=1MHz)
  OSCCAL_calibration();					// RCUZ
  CONTRAST = 0x0F;						// LCDZWőݒ
  DDRB = 0xF0;							// ߰BPB7`4o͐ݒ(STK500LEDSp)
  DDRE = 0x00;							// ߰E͐ݒ(STK500SWITCHESp)
  PWM_init();							// /1łPWM
  RTC_init();							// /232kHzۯ񓯊ݒ
// A/Dϊݸ ނ܂͍̂ǂ炩IсA𒍎߂ɂĂB
  ADC_init(SingleEnded);				// A/Dϊݸ ޓŏ
//  ADC_init(Differential);				// A/Dϊŏ
  UART_init(12);						// USART
  LCD_Init();							// LCD
  LCDsetupData();						// LCD۰ٕ\ݒ
  __enable_interrupt();					// S̊荞݋
}

/*! \brief	xٰ
 *  \param  i	- xwl
 */
void Delay(int i)
{
  int j,k;

  for(k=1;k<=i;k++)
  {
	for(j=1;j<=124;j++);
  }
}

/*! \brief	ƂĊO32kHzؽقgpēRCUZ
 */
void OSCCAL_calibration(void)
{
  unsigned char calibrate = FALSE;
  int temp;
  unsigned char tempL;

  CLKPR = (1<<CLKPCE);					//  ۯOuύX
  CLKPR = (1<<CLKPS1) | (1<<CLKPS0);	//  ۯOu8ݒ(8MHz/8=1MHz)
  TIMSK2 = 0;							// /2S荞݋֎~
  ASSR = (1<<AS2);						// /2񓯊I(32.768kHz)
  OCR2A = 200;							// p32.768kHzvlw
  TIMSK1 = 0;							// /1S荞݋֎~
  TCCR1B = (1<<CS10);					// OuȂ/1n
  TCCR2A = (1<<CS20);					// OuȂ/2n
  while(ASSR & (0x01 | 0x04));			// T/C2XVmF(TCN2UB,TCR2UB=0)
  Delay(1000);							// 32.768kHzؽو莞ԑҋ@

  while(!calibrate)						// ͈͓B܂Ōp
  {
	__disable_interrupt();				// S̊荞݋֎~
	TIFR1 = 0xFF;						// /1S荞ݗv׸މ
	TIFR2 = 0xFF;						// /2S荞ݗv׸މ
	TCNT1H = 0;							// /1l
	TCNT1L = 0;
	TCNT2 = 0;							// /2l
	while ( !(TIFR2 && (1<<OCF2A)) );	// 32.768kHz200ҋ@
	TCCR1B = 0;							// /1~
	__enable_interrupt();				// S̊荞݋
	if ( (TIFR1 && (1<<TOV1)) )			// /1ŁA
	{
	  temp = 0xFFFF;					// T/C1lőlɐݒ
	}
	else								// /1ȂŁA
	{
	  tempL = TCNT1L;					// /1l擾
	  temp = TCNT1H;
	  temp = (temp << 8);
	  temp += tempL;
	}
	if (temp > 6250)					// ŁA
	{
	  OSCCAL--;							// Zl
	}
	else if (temp < 6120)				// xŁA
	{
	  OSCCAL++;							// Zl
	}
	else								// ͈͓ŁA
	  calibrate = TRUE;					// Z׸ސݒ
	  TCCR1B = (1<<CS10);				// /1Ďn(ZĊJ)
  }
}

/*! \mainpage
 * \section intro 
 * AVR064:LCDo͕txĎщpLqpĳ̎łBSTK502
 * ATmega169(P)̎gp@̗Ӑ}Ă܂B
 *
 * \section compinfo ߲׏
 * IAR Embedded Workbench 4.12Aź߲ق܂BGCCgpɂͿ
 * ύXȂ΂Ȃ܂B\n
 * IAR EWAVRۼުĂ쐬ɂ́A\n
 * ۼުĂ.ç(Main.c,Buttons.c,LCD_driver.c,LCD_functions.c,RTC.c,Tempera
 * ture.c and UART.c)ǉĂB"device --cpu=m169"A"enable bit defin
 * itions in I/O include files"Aޯޗpɏo͌`ubrof8Aopintel_ext
 * endedgpĂB\n
 * SRAMʒuɒ`ϐ̕s邽߂ݶ ̧قύXׂƂɂ
 * ӂĂ(Main.h)B
 *
 * \section deviceinfo ޲
 * ATmega169(P)pɏĂ܂B֐Ɋ֘AݸނSTK502ɔzu
 * ꂽO32kHzؽقۯ쓮RTCۯLCDڰёxA1MHzU
 * pɏĂ܂BڑAA˭ނ͉pLqɋLڂĂ܂B
 *
 * \section contactinfo Contact Info
 * ATMELAVRɂĂ̂葽̏ɊւĂ͈ȉK˂ĂB
 * <A href="http://www.atmel.com/products/AVR/" >Atmel AVR</A> \n
 * pLqɊւĂ:
 * <A href="http://www.atmel.com/dyn/products/app_notes.asp?family_id=607">AVR Application Notes</A>\n
 * xҰ: avr@atmel.com
 */
