/* ̧قDoxygenpɏĂ܂B*/
/*! \file ********************************************************************
 *
 * \brief
 *	x
 *
 * \par Application note:
 *	AVR064: LCDo͕txĎ
 *
 * \par Documentation:
 *	IȺގAxׁ߲A߲אݒAx޲ɂĂreadme.html
 *	B
 *
 * \author
 *	Atmel Corporation: http://www.atmel.com \n
 *	xEҰ: avr@atmel.com
 *
 * $Name: RELEASE_1_1 $
 * $Revision: 1.3 $
 * $RCSfile: Temperature.c,v $
 * $Date: 2006/02/16 18:11:22 $  \n
 ******************************************************************************/

// ݸٰ ̧
#include "Main.h"
#include "Temperature.h"
#include "math.h"

// Sϐ
unsigned char ADCresult_calc_cnt = 0;	// A/Dϊ񐔌v
int ADCresult_average = 0;				// A/Dϊl
float Temperature;						// xvZƒl

/*! \brief	A/Dϊ평Ƌ[A/Dϊs
 *  \param	Operation	- ّIl
 */
void ADC_init(unsigned char Operation)
{
  SET_POINT = 25;						// ݒ_25ɐݒ
  ADMUX |= Operation;					// َw
  Delay(50);							// ّIpx[Ӗ]
  ADCSRA = (1<<ADEN) | (1<<ADPS1) | (1<<ADPS0);		// 8Ou(1MHz/8=125kHz)A/Dϊ틖
  DIDR1 = 0xFF;							// ADC߰Ă̑S޼ٓ͋֎~
  ADC_conversion();						// ̂߂ɏϊs
}

/*! \brief	ʑ/g10ޯPWM/1
 */
void PWM_init(void)
{
  ICR1H = 0x03;							// TOPl10ޯĂɐݒ
  ICR1L = 0xFF;
  OCR1AH = OCR1BH = 0x00;				// PWMlݒ
  OCR1AL = OCR1BL = 0xF0;
  TCCR1A = (1<<COM1A1) | (1<<COM1A0) | (1<<COM1B1) | (1<<COM1B0);	// ㏸vł̈vŐݒ,~vł̈vŉOC1A/Bݒ
  TCCR1B = (1<<WGM13) | (1<<CS11);		// ʑ/gPWM,8Ou/1n
}

/*! \brief A/Dϊs
 */
void ADC_conversion(void)
{
  int ADC_temp;
  int ADCresult = 0;
  unsigned char i;

  for(i=0;i<8;i++)						// xP̂8̎
  {
	ADCSRA |= (1<<ADSC);				// PƕϊJn
	while(!(ADCSRA & 0x10));			// A/Dϊҋ@
	ADC_temp = ADCL;					// A/Dϊl擾
	ADC_temp += (ADCH << 8);
	ADCresult += ADC_temp;				// A/DϊlώZ
  }
  ADCresult = ADCresult >> 3;			// 8̎̕ϒl擾
  ADCresult_calc_cnt++;					// 32ώZvis
  ADCresult_average += ADCresult;		// 32ώZlXV
  if(ADCresult_calc_cnt >= 32)			// 32ώZŁA
  {
	ADCresult_calc_cnt = 0;				// 32ώZv평
	ADCresult_average = ADCresult_average >> 5;		// 32ώZl̕ϒl擾
	Temp_calculation(ADCresult_average);			// xlϊ
	ADCresult_average = 0;				// 32ݐϊ평
  }
}

/*! \brief	A/Dϊˉxϊ
 *  \param	iADC_value	- A/Dϊl
 */
void Temp_calculation(int iADC_value)
{
  float V_ADC;

  if((ADMUX & 0x1F) == SingleEnded)				// ݸ ޓ͓ŁA
	V_ADC = (iADC_value * V_ref)/1024;			// NTCнd擾
  else if((ADMUX & 0x1F) == Differential)		// ͓ŁA
	V_ADC = (iADC_value * V_ref)/512;			// NTCнd擾

  Temperature = (Beta / ((log(V_ADC/(V_ref-V_ADC))/log(__E)) + (Beta/T_amb))) - T_zero;	// xl擾

  TEMP_HIGHBYTE = Temperature;					// 擾
  Temperature = (Temperature - TEMP_HIGHBYTE);	// ̂ݎ擾
  TEMP_LOWBYTE = (Temperature * 100);			// ~100𐮐ƂĎ擾

  Temperature_regulation();						// x(M/po͏)
}

/*! \brief	ݒ_Ƃ̉x擾APWMLEDɉxóB
 */
void Temperature_regulation(void)
{
  int Offset_OCR1;
  unsigned char PWM_8LSB;
  unsigned char PWM_2MSB;

  OFFSET = (TEMP_HIGHBYTE - SET_POINT);		// ݒ_Ǝx̉x擾
  if( OFFSET & 0x80 )					// -ȂA
  {
	OFFSET =~ OFFSET;					// lϊ(1̕␔)
	if(OFFSET > 0)						// 1(-1)ȏ̍ŁA
	{
	  TCCR1A &= 0x0F;					// COM1Ax,COM1Bxޯĉ(pPWM֎~)
	  TCCR1A |= 0xC0;					// COM1A1,COM1A0ޯĐݒ(MPWM)
	  PORTB = Heater;					// MPWM=L(H)o͐ݒ
	}
  }
  else if( OFFSET )						// +1ȏȂA
  {
	TCCR1A &= 0x0F;						// COM1Ax,COM1Bxޯĉ(MPWM֎~)
	TCCR1A |= 0x30;						// COM1B1,COM1B0ޯĐݒ(pPWM)
	PORTB = Cooler;						// pPWM=L(H)o͐ݒ
  }
  else									// }0ŁA
  {
	TCCR1A &= 0x0F;						// COM1Ax,COM1Bxޯĉ(M/pPWM֎~)
	PORTB = (1<<PORTB6) | (1<<PORTB5);	// LED5,LED6(STK500LEDSLow)
  }
  Offset_OCR1 = OFFSET;					// xΒl
  Offset_OCR1 *= (Offset_OCR1 * 2);		// Βl~(Βl~2) (10ޯPWMɑ΂鑝)
  if(Offset_OCR1 > 0x03FF)				// 10ޯPWMőlzŁA
	Offset_OCR1 = 0x3FF;				// őlɕύX
  PWM_8LSB = Offset_OCR1;				// PWM8ޯĒl擾
  Offset_OCR1 >>= 8;					// 2ޯĂ޲Ăֈړ
  PWM_2MSB = Offset_OCR1;				// PWM2ޯĒl擾
  OCR1AH = OCR1BH = PWM_2MSB;			// PWMlXV
  OCR1AL = OCR1BL = PWM_8LSB;
}
